﻿using System;
using System.Text;
using System.Collections.Generic;
using System.IO;
using System.Security.AccessControl;
using System.Security.Principal;
using System.Linq;
using CompleteEraser.Properties;

namespace CompleteEraser
{
    class FileBreaker
    {

        public static void BreakFileOrFolder(string path)
        {
            if (Directory.Exists(path))
                BreakFolder(path);
            else if (File.Exists(path))
                BreakFile(path);
        }

        public static void BreakFile(string file)
        {
            FileAttributes attr = File.GetAttributes(file);
            if ((attr & FileAttributes.ReadOnly) == FileAttributes.ReadOnly)
                File.SetAttributes(file, attr & ~FileAttributes.ReadOnly);

            string ext = Path.GetExtension(file);

            if (Settings.Default.AlwaysSlowSpeed || Settings.Default.SlowSpeedExt.IndexOf(ext) != -1)
                BreakFileSlowSpeed(file);
            else
                BreakFileHiSpeed(file);
            
            string newFile = GenerateRandoName(Path.GetDirectoryName(file), file.Length);
            File.Move(file, newFile);
            
            File.Delete(newFile);
        }

        private static void BreakFileSlowSpeed(string file)
        {
            FileStream fs = new FileStream(file, FileMode.Open);
            fs.Seek(0, SeekOrigin.Begin);
            for (long i = 0; i < fs.Length; i++)
                fs.WriteByte(0);
            fs.Close();
        }

        private static void BreakFileHiSpeed(string file)
        {
            FileStream fs = new FileStream(file, FileMode.Open);
            fs.Seek(0, SeekOrigin.Begin);

            byte[] data = new byte[Settings.Default.FillLengthAtHiSpeed];
            fs.Write(data, 0, data.Length);
            fs.Seek(-data.Length, SeekOrigin.End);
            fs.Write(data, 0, data.Length);
            fs.Close();
        }

        public static void BreakFolder(string folder)
        {
            IEnumerable<string> files = Directory.GetFiles(folder, "*.+", SearchOption.AllDirectories);
            foreach (string file in files)
                BreakFile(file);
            string newName = GenerateRandoName(Path.GetDirectoryName(folder), Path.GetFileName(folder).Length);
            if ((FileAccessPermissionHelper.GetCurrentAccessRule(folder).FileSystemRights & FileSystemRights.Modify) == FileSystemRights.Modify)
                Directory.Move(folder, newName);
            else
                throw new UnauthorizedAccessException();
            Directory.Delete(newName, true);
        }

        private static string GenerateRandoName(string dirpath, int length)
        {
            string list = "abcdefghijklmnopqrstuvwxyz0123456789";
            Random rnd = new Random();
            StringBuilder output = new StringBuilder();
            for (int i = 0; i < length; i++)
                output.Append(list[rnd.Next(list.Length - 1)]);
            return dirpath + "\\" + output.ToString();
        }
    }

    public static class FileAccessPermissionHelper
    {
        // 書き込み権限持ってる？
        public static bool IsGotPermission(string path)
        {
            var rule = GetCurrentAccessRule(path);
            return ((rule != null) && ((rule.FileSystemRights & FileSystemRights.Write) == FileSystemRights.Write));
        }

        // 現在のユーザーが持っている指定パスのFileSystemAccessRuleを得る
        public static FileSystemAccessRule GetCurrentAccessRule(string path)
        {
            var fileSecurity = File.GetAccessControl(path);
            var rules = fileSecurity.GetAccessRules(true, true, typeof(SecurityIdentifier)).OfType<FileSystemAccessRule>();
            var currentIdentity = WindowsIdentity.GetCurrent();
            var sids = new[] { currentIdentity.User }.Concat(currentIdentity.Groups);

            // アクセスルール内にユーザーSIDがある？無ければグループSIDも探す
            return rules.FirstOrDefault(rule => sids.Contains(rule.IdentityReference));
        }
    }
}
